#include <stdio.h>
#include <stdlib.h>

// Modification of capitalize.c to
// show how an array passed to a function
// is treated as a pointer.

static char cap_diff = 'a'-'A';

/* makes a string uppercase, in place
 */
void capitalize(char* s) {
  printf("argument: %p\n", s); 
  printf("address of argument: %p\n", &s); 

  char* p = s;
  while (*p != '\0') {
    if (*p < 'a' || *p > 'z') {
      fprintf(stderr, "only works on lowercase letters\n");
      exit(2);
    }
    *p -= cap_diff;
    ++p;
  }
}

/* takes a lowercase string of ascii characters
 * and prints it in uppercase
 */
int main(int argc, char** argv) {
  char input[100] = "epiphany";

  printf("Input, string: %s, value: %p, address: %p\n", input, input, &input);
  capitalize(input);
  printf("Output: %s\n", input);
}
